# Contributing

Please note that you don't *need* the below setup to contribute. But it does allow
for phpcs and phpstan to run locally, making you aware of any issues before you
push the code.

They'll get caught in the pipeline either way, but it's more convenient to also
have these locally.

## Requirements

* ddev
* ddev-drupal-config

For a more optimal developer experience ddev-drupal-contrib is used so hooks
can be run locally. [You can read on how to install DDEV here.](https://ddev.readthedocs.io/en/stable/#installation)

Once ddev is installed, [also install ddev-drupal-contrib.](https://github.com/ddev/ddev-drupal-contrib)

When that's done you should run `composer install` once, and then:

```
ddev start
ddev poser
ddev symlink-project
ddev config --update
ddev restart
```

Now you can run phpcs and phpstan:

```
ddev phpcs
ddev phpstan
```

